/*-------------------------------------------------------------
 * stdlib.h
 *
 * Header file for standard library functions.
 *-------------------------------------------------------------*/

#ifndef STDLIB_H
#define STDLIB_H

#include "syscall.h"

#define NULL	0L
#define TRUE	1
#define FALSE	0

#define min(a,b)  (((a) < (b)) ? (a) : (b))
#define max(a,b)  (((a) > (b)) ? (a) : (b))

#define divRoundDown(n,s)  ((n) / (s))
#define divRoundUp(n,s)    (((n) / (s)) + ((((n) % (s)) > 0) ? 1 : 0))

#define ASSERT	assert
#define assert(_EX)	((_EX) ? (void) 0 : __assert(#_EX, __FILE__, __LINE__))
void __assert(char* expression, char* file, int line);

#define ASSERTNOTREACHED()	ASSERT(FALSE)

void *memcpy(void *s1, const void *s2, unsigned n);
void *memset(void *s, int c, unsigned n);

unsigned strlen(const char* str);
int strcpy(char* dst, const char* src);
int strcmp(const char* a, const char* b);
int strncmp(const char* a, const char* b, int n);

int atoi(const char* s);

#endif // STDLIB_H
