// rider.cc
//	Implementation of the rider controller.
//
//	Not yet implemented.
//
// Copyright (c) 1992-1996 The Regents of the University of California.
// All rights reserved.  See copyright.h for copyright notice and limitation 
// of liability and disclaimer of warranty provisions.

#include "copyright.h"
#include "rider.h"

//----------------------------------------------------------------------
// Rider::Start
//	The thread that instantiates the elevator bank forks a thread to
//	this method to dispatch riders. This method should set up a callback
//	through the interface and fork any threads necessary to control the
//	riders. The thread that calls this method must be terminated when all
//	the riders are done.
//
//	The elevator bank requires that each rider run in one thread. Whenever
//	a rider calls an action routine on the rider interface (i.e.
//	PressButton, EnterElevator, PressFloor, or ExitElevator), the call
//	must be made from that rider's thread.
//
//	"numRiders" specifies how many rider threads should be forked.
//	riderStops is an array of lists of floors: riderStops[i] is a list
//	of floors that rider# i must visit IN ORDER. The rider should only
//	move up and down floors by using the elevator bank accessible through
//	the provided RiderInterface object. The rider should always call
//	Alarm::WaitUntil(RiderDelay) every time it gets off the elevator.
//
//	For example, if riderStops[0] is the list containing (1, 3, 2)
//	in that order, then rider 0 should enter an elevator at floor 1, get
//	off at floor 3, call WaitUntil(RiderDelay), get on an elevator at
//	floor 3, get off at floor 2, call WaitUntil(RiderDelay), and then call
//	kernel->currentThread->Finish().
//
//	Rider threads should NEVER communicate with elevator threads, or with
//	the elevator bank. The RiderInterface class is sufficient.
//----------------------------------------------------------------------
void
RiderController::Start(RiderInterface* interface, int numRiders,
		       List<int> riderStops[])
{
}
